package io.zipcoder.tc_spring_poll_application.controller;

import io.zipcoder.tc_spring_poll_application.domain.Vote;
import io.zipcoder.tc_spring_poll_application.dtos.OptionCount;
import io.zipcoder.tc_spring_poll_application.dtos.VoteResult;
import io.zipcoder.tc_spring_poll_application.repositories.VoteRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

@RestController
public class ComputeResultController {

    private VoteRepository voteRepository;

    @Autowired
    public ComputeResultController(VoteRepository voteRepository) {
        this.voteRepository = voteRepository;
    }

    @RequestMapping(value = "/computeresult", method = RequestMethod.GET)
    public ResponseEntity<?> computeResult(@RequestParam Long pollId) {
        VoteResult voteResult = new VoteResult();
        Iterable<Vote> allVotes = voteRepository.findVotesByPoll(pollId);
        Map<Long, Integer> mapOptions = new HashMap<>();
        int voteCount = 0;
        for(Vote vote:allVotes){
            voteCount++;
            if(!mapOptions.containsKey(vote.getOption().getId())){
                mapOptions.put(vote.getOption().getId(),1);
            }else{
                int count = mapOptions.get(vote.getOption().getId());
                count +=1;
                mapOptions.put(vote.getOption().getId(),count);
            }
        }
        Collection<OptionCount> optionCounts = new ArrayList<>();
        for(Long l:mapOptions.keySet()){
            OptionCount optionCount = new OptionCount();
            optionCounts.add(optionCount);
        }
        voteResult.setResults(optionCounts);
        voteResult.setTotalVotes(voteCount);

        return new ResponseEntity<VoteResult>(voteResult, HttpStatus.OK);
    }

}
